#include "ModifyItemDlg.h"
#include <direct.h>

extern CModifyItemDlg *pModifyItemDlg;

class CEditUI
{
public:
    CZUIManager *m_pUIManager;
    D3DXVECTOR2 point;
    D3DXVECTOR2 point2;
    int m_selectedTexture;
    int m_selectedFontID;
    ZUILineVertex vCreatingRect[2];
    int selectedItemID;
    bool mouseDown;
    D3DXVECTOR2 lastMoustPos;
    float lastRHW;
    int pointSize;
    int selectedPoint;
    int creatingType;
    int m_CaptureEvents;
    int m_CaptureItem;
    int m_mouseOverItemID;
    
    int *m_EditboxTexIDs;
    int *m_CheckboxTexIDs;
    int *m_ButtonTexIDs;
    int *m_SliderTexIDs;

    CEditUI()
    {
        m_pUIManager = new CZUIManager;
        m_selectedTexture = -1;
        selectedItemID = -1;
        mouseDown = false;
        lastRHW = 0.5001f;
        pointSize = 4;
        selectedPoint = -1;
        creatingType = -1;
        m_CaptureEvents = 0;
        m_mouseOverItemID = -1;
        m_selectedFontID = -1;

        m_EditboxTexIDs = new int[2];
        memset(m_EditboxTexIDs,-1,sizeof(int)*2);

        m_CheckboxTexIDs = new int[6];
        memset(m_CheckboxTexIDs,-1,sizeof(int)*6);

        m_ButtonTexIDs = new int[2];
        memset(m_ButtonTexIDs,-1,sizeof(int)*2);

        m_SliderTexIDs = new int[2];
        memset(m_SliderTexIDs,-1,sizeof(int)*2);
    }
    
    ~CEditUI()
    {
        if(m_pUIManager)
            delete m_pUIManager;

        delete[] m_EditboxTexIDs;
        delete[] m_CheckboxTexIDs;
        delete[] m_ButtonTexIDs;
        delete[] m_SliderTexIDs;
    }

    void Render()
    {
        m_pUIManager->Render();

        if( selectedItemID != -1)
        {
            CZUIItem *pItem = m_pUIManager->GetItem(selectedItemID);
            point.x = pItem->x;
            point.y = pItem->y;
            point2.x = pItem->x+pItem->width;
            point2.y = pItem->y+pItem->height;

            g_pDevice->SetTexture(0,NULL);
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_DIFFUSE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );

            g_pDevice->SetVertexShader(FVF_ZUILINEVERTEX);
            vCreatingRect[0].color = 
            vCreatingRect[1].color = D3DCOLOR_XRGB(255,0,0);
            vCreatingRect[0].rhw   = 
            vCreatingRect[1].rhw   = 0.0;
            vCreatingRect[0].z = 
            vCreatingRect[1].z = 0.0;

            //top left bottom left
            vCreatingRect[0].x = point.x;
            vCreatingRect[0].y = point.y;
            vCreatingRect[1].x = point.x;
            vCreatingRect[1].y = point2.y;
            g_pDevice->DrawPrimitiveUP(D3DPT_LINELIST,1,vCreatingRect,sizeof(ZUILineVertex));
            
            //bottom left bottom right
            vCreatingRect[0].x = point.x;
            vCreatingRect[0].y = point2.y;
            vCreatingRect[1].x = point2.x;
            vCreatingRect[1].y = point2.y;
            g_pDevice->DrawPrimitiveUP(D3DPT_LINELIST,1,vCreatingRect,sizeof(ZUILineVertex));

            //bottom right top right
            vCreatingRect[0].x = point2.x;
            vCreatingRect[0].y = point2.y;
            vCreatingRect[1].x = point2.x;
            vCreatingRect[1].y = point.y;
            g_pDevice->DrawPrimitiveUP(D3DPT_LINELIST,1,vCreatingRect,sizeof(ZUILineVertex));

            //top right top left
            vCreatingRect[0].x = point2.x;
            vCreatingRect[0].y = point.y;
            vCreatingRect[1].x = point.x;
            vCreatingRect[1].y = point.y;
            g_pDevice->DrawPrimitiveUP(D3DPT_LINELIST,1,&vCreatingRect[0],sizeof(ZUILineVertex));


            int x,y;

            //top point
            if(selectedPoint == 0)
                vCreatingRect[0].color = D3DCOLOR_XRGB(0,255,0);
            else
                vCreatingRect[0].color = D3DCOLOR_XRGB(0,0,255);

            for(x=-pointSize;x<pointSize;x++)
            {
                for(y=-pointSize;y<pointSize;y++)
                {
                    
                    vCreatingRect[0].x = (point.x+point2.x)/2 +x;
                    vCreatingRect[0].y = point.y+y;
                    g_pDevice->DrawPrimitiveUP(D3DPT_POINTLIST,1,&vCreatingRect[0],sizeof(ZUILineVertex));
                }
            }

            //right point
            if(selectedPoint == 1)
                vCreatingRect[0].color = D3DCOLOR_XRGB(0,255,0);
            else
                vCreatingRect[0].color = D3DCOLOR_XRGB(0,0,255);

            for(x=-pointSize;x<pointSize;x++)
            {
                for(y=-pointSize;y<pointSize;y++)
                {
                    vCreatingRect[0].x = point2.x+x;
                    vCreatingRect[0].y = (point.y+point2.y)/2+y;
                    g_pDevice->DrawPrimitiveUP(D3DPT_POINTLIST,1,&vCreatingRect[0],sizeof(ZUILineVertex));
                }
            }

            //bottom point
            if(selectedPoint == 2)
                vCreatingRect[0].color = D3DCOLOR_XRGB(0,255,0);
            else
                vCreatingRect[0].color = D3DCOLOR_XRGB(0,0,255);

            for(x=-pointSize;x<pointSize;x++)
            {
                for(y=-pointSize;y<pointSize;y++)
                {
                    vCreatingRect[0].x = (point.x+point2.x)/2+x;
                    vCreatingRect[0].y = point2.y+y;
                    g_pDevice->DrawPrimitiveUP(D3DPT_POINTLIST,1,&vCreatingRect[0],sizeof(ZUILineVertex));
                }
            }


            //left point
            if(selectedPoint == 3)
                vCreatingRect[0].color = D3DCOLOR_XRGB(0,255,0);
            else
                vCreatingRect[0].color = D3DCOLOR_XRGB(0,0,255);

            for(x=-pointSize;x<pointSize;x++)
            {
                for(y=-pointSize;y<pointSize;y++)
                {
                    vCreatingRect[0].x = point.x+x;
                    vCreatingRect[0].y = (point2.y+point.y)/2+y;
                    g_pDevice->DrawPrimitiveUP(D3DPT_POINTLIST,1,&vCreatingRect[0],sizeof(ZUILineVertex));
                }
            }

            
        }

        //draw virtual viewport
        {
            g_pDevice->SetTexture(0,NULL);
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_DIFFUSE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );
            g_pDevice->SetTextureStageState( 1, D3DTSS_COLOROP,   D3DTOP_DISABLE );
            g_pDevice->SetTextureStageState( 1, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );


            g_pDevice->SetRenderState( D3DRS_SHADEMODE, D3DSHADE_FLAT);
            g_pDevice->SetRenderState( D3DRS_COLORVERTEX, FALSE);
            g_pDevice->SetRenderState( D3DRS_LIGHTING, FALSE);   

            g_pDevice->SetVertexShader(FVF_ZUILINEVERTEX);
            vCreatingRect[0].color = 
            vCreatingRect[1].color = D3DCOLOR_XRGB(255,0,255);
            vCreatingRect[0].rhw   = 
            vCreatingRect[1].rhw   = 0.0;
            vCreatingRect[0].z = 
            vCreatingRect[1].z = 0.0;

            //top right to bottom right
            vCreatingRect[0].x = m_pUIManager->m_virtualWidth - m_pUIManager->m_xoffset;
            vCreatingRect[0].y = 0;
            vCreatingRect[1].x = m_pUIManager->m_virtualWidth - m_pUIManager->m_xoffset;
            vCreatingRect[1].y = m_pUIManager->m_virtualHeight - m_pUIManager->m_yoffset;
            g_pDevice->DrawPrimitiveUP(D3DPT_LINELIST,1,vCreatingRect,sizeof(ZUILineVertex));

            //bottom left to bottom right
            vCreatingRect[0].x = 0;
            vCreatingRect[0].y = m_pUIManager->m_virtualHeight - m_pUIManager->m_yoffset;
            vCreatingRect[1].x = m_pUIManager->m_virtualWidth - m_pUIManager->m_xoffset;
            vCreatingRect[1].y = m_pUIManager->m_virtualHeight - m_pUIManager->m_yoffset;
            g_pDevice->DrawPrimitiveUP(D3DPT_LINELIST,1,vCreatingRect,sizeof(ZUILineVertex));
            
        }
    }

    void MouseMove(int x,int y)
    {
        if(m_CaptureEvents == 1)
        {
            selectedItemID = -1;

            CZUIItem *pItem = m_pUIManager->GetItem(m_pUIManager->GetItemFromPoint(x,y));
            if(pItem)
            {
                if(m_mouseOverItemID != -1)
                    if(m_mouseOverItemID != pItem->m_ID)
                    {
                        m_pUIManager->GetItem(m_mouseOverItemID)->MouseOff();
                    }

                if(mouseDown)
                    pItem->MouseDown(1,x,y);
                else
                    pItem->MouseMove(x,y);
                m_mouseOverItemID = pItem->m_ID;
            }
            else
            {
                if(m_mouseOverItemID != -1)
                {
                    pItem = m_pUIManager->GetItem(m_mouseOverItemID);
                    if(pItem)
                    {
                        pItem->MouseOff();
                    }
                    m_mouseOverItemID = -1;
                }
            }
        }
        else if(mouseDown && selectedItemID!=-1)
        {
            CZUIItem *pItem = m_pUIManager->GetItem(selectedItemID);

            //set the position in the modify position edit box
            CString pString;
            pString.Format("%.2f , %.2f",m_pUIManager->m_xoffset +  pItem->x,m_pUIManager->m_yoffset + pItem->y);
            pModifyItemDlg->SetDlgItemText(IDC_MODIFY_POSITION,pString);

            if(selectedPoint != -1)
            {
                switch(selectedPoint)
                {
                    //top
                    case 0:
                    {
                        pItem->y -= lastMoustPos.y - y;
                        pItem->height += lastMoustPos.y - y;
                    }
                    break;

                    //right
                    case 1:
                    {
                        pItem->width -= lastMoustPos.x - x;
                    }
                    break;

                    //bottom
                    case 2:
                    {
                        pItem->height -= lastMoustPos.y - y;
                    }
                    break;

                    //left
                    case 3:
                    {
                        pItem->x -= lastMoustPos.x - x;
                        pItem->width += lastMoustPos.x - x;
                    }
                    break;
                }
            }
            else
            {
                //moving the object
                pItem->x -= lastMoustPos.x - x;
                pItem->y -= lastMoustPos.y - y;
            }
            pItem->Initialize();
        }
        lastMoustPos.x = x;
        lastMoustPos.y = y;
    }

    void MouseUp(int btn,int x,int y)
    {
        mouseDown = false;
        if(m_mouseOverItemID != -1)
        {
            CZUIItem *pItem = m_pUIManager->GetItem(m_mouseOverItemID);
            if(pItem)
            {
                pItem->MouseUp(btn,x,y);
            }
        }
    }

    void DeleteSelected()
    {
        if(selectedItemID!=-1)
        {
            m_pUIManager->RemoveItem(selectedItemID);
            selectedItemID = -1;
        }
    }

    void MouseClick(int btn,int x,int y)
    {
        if(btn == 1)
        {
            mouseDown = true;
        }

        //check to see if a point was selected
        if(selectedItemID != -1)
        {
            CZUIItem *pItem = m_pUIManager->GetItem(selectedItemID);
            if(pItem)
            {
                //point 0 -- top
                if(x>=(pItem->x+pItem->width/2)-pointSize && x <= (pItem->x+pItem->width/2)+pointSize &&
                    y>=pItem->y-pointSize && y <= pItem->y+pointSize)
                {
                    selectedPoint = 0;
                    return;
                }

                //point 1 -- right
                if(x>=pItem->x+pItem->width-pointSize && x <= pItem->x+pItem->width+pointSize &&
                    y>=pItem->y+pItem->height/2-pointSize && y <= pItem->y+pItem->height/2+pointSize)
                {
                    selectedPoint = 1;
                    return;
                }

                

                //point 2 -- bottom
                if(x>=pItem->x+pItem->width/2-pointSize && x <= (pItem->x+pItem->width/2)+pointSize &&
                    y>=pItem->y+pItem->height-pointSize && y <= pItem->y+pItem->height+pointSize)
                {
                    selectedPoint = 2;
                    return;
                }

                //point 3 -- left
                if(x>=(pItem->x)-pointSize && x <= (pItem->x)+pointSize &&
                    y>=pItem->y+pItem->height/2-pointSize && y <= pItem->y+pItem->height/2+pointSize)
                {
                    selectedPoint = 3;
                    return;
                }

            }
            selectedPoint = -1;
        }//if selected item != -1

        lastMoustPos.x = x;
        lastMoustPos.y = y;

        if(m_CaptureEvents == 1)
        {
            m_CaptureItem = m_pUIManager->GetItemFromPoint(x,y);
            if(m_CaptureItem != -1)
            {
                CZUIItem *pItem = m_pUIManager->GetItem(m_CaptureItem);
                if(pItem)
                {
                    pItem->MouseDown(btn,x,y);
                }
            }
        }
        else
        {
            int oldSel = selectedItemID;
            selectedItemID = m_pUIManager->GetItemFromPoint(x,y);
            if(selectedItemID != oldSel)
            {
                CZUIItem *pItem = m_pUIManager->GetItem(oldSel);
                if(pItem)
                {
                    if(pItem->IsA(ZUI_EDITBOX))
                    {
                        CZUIEditBox *pEdit = static_cast<CZUIEditBox*>(pItem);
                        pEdit->SetSel(-1);
                    }
                }
            }

            //if there is an object selected, select its type radio button
            if(selectedItemID != -1)
            {
                CZUIItem *pItem = m_pUIManager->GetItem(selectedItemID);
                
                if(pItem->m_name.length())
                    pModifyItemDlg->SetDlgItemText(IDC_MODIFY_NAME,pItem->m_name.c_str());
                else
                    pModifyItemDlg->SetDlgItemText(IDC_MODIFY_NAME,"");

                //set the translucency slider and edit box
                CString pString;
                pString.Format("%d",pItem->m_iTranslucency);
                pModifyItemDlg->SetDlgItemText(IDC_MODIFY_TRANSLUCENCY,pString);
                CSliderCtrl *pTransSlider = (CSliderCtrl*)
                                pModifyItemDlg->GetDlgItem(IDC_SLIDER_TRANSLUCENCY);
                pTransSlider->SetPos(pItem->m_iTranslucency);



                //set the position in the modify position edit box
                pString.Format("%.2f , %.2f",m_pUIManager->m_xoffset +  pItem->x,m_pUIManager->m_yoffset + pItem->y);
                pModifyItemDlg->SetDlgItemText(IDC_MODIFY_POSITION,pString);

                pModifyItemDlg->CheckDlgButton(IDC_CALLBACK_EVENT,pItem->m_bCallbackEvent?1:0);
                
                //if its an edit box, set its current selection to be the end of the string
                if(pItem->IsA(ZUI_EDITBOX))
                {
                    CZUIEditBox *pEdit = static_cast<CZUIEditBox*>(pItem);
                    if(pEdit)
                    {
                        if(pEdit->m_text.length() > 0)
                        {
                            CZUIFont *pFont = m_pUIManager->GetFont(pEdit->m_fontID);
                            if(pFont)
                            {
                                if(pFont->m_pFont)
                                {
                                    SIZE sizeXLoc;
                                    pFont->m_pFont->GetTextExtent(
                                            (char*)pEdit->m_text.c_str(),&sizeXLoc);

                                    pEdit->SetSel(sizeXLoc.cx);
                                }
                            }
                        }
                    }
                } // if(pItem->IsA(ZUI_EditBox)
            }
            else
            {
                pModifyItemDlg->SetDlgItemText(IDC_MODIFY_NAME,"");
            }
        }
    }
 
};
