#include "d3dfont.h"

class CZUIFont
{
public:
    CD3DFont *m_pFont;
    std::string m_text;
    std::string m_fontName;
    float x,y;
    long m_color;
    long m_size;
    long m_style;
    unsigned int m_ID;

    void SetFont(const char *fontName,long size,long color,long style)
    {
        DeleteDevice();
        m_color = color;
        m_size = size;
        m_style = style;
        m_fontName = fontName;
        m_pFont = new CD3DFont((char*)fontName,m_size,style);
        m_pFont->InitDeviceObjects(g_pDevice);
        m_pFont->RestoreDeviceObjects();
    }

    void Render()
    {
        char buff[255];
        sprintf(buff,m_text.c_str());
        m_pFont->DrawText(x,y,m_color,(char*)buff);
    }

    CZUIFont()
    {
        m_pFont = NULL;
    }

    ~CZUIFont()
    {
        DeleteDevice();
    }

    void InvalidateDevice()
    {
        m_pFont->InvalidateDeviceObjects();
    }

    void RestoreDevice()
    {
        m_pFont->RestoreDeviceObjects();
    }
    
    void DeleteDevice()
    {
        if(m_pFont)
        {
            m_pFont->DeleteDeviceObjects();
            delete m_pFont;
        }
        m_pFont = NULL;
    }
};