class CZUITexture
{
public:
    LPDIRECT3DTEXTURE8 m_tex;
    unsigned int m_ID;
    std::string m_fileName;
    bool translucent;
    int m_opacity;
    int m_width,m_height;

    void LoadTexture(const char *fileName)
    {
        D3DXCreateTextureFromFile(g_pDevice,fileName,&m_tex);
        D3DSURFACE_DESC desc;
        m_tex->GetLevelDesc(0,&desc);
        m_width = desc.Width;
        m_height = desc.Height;
    }

    CZUITexture()
    {
        m_tex = 0;
        m_opacity = 0;
        translucent = false;
        m_width = 0;
        m_height = 0;
    }

    ~CZUITexture()
    {
        Release();
    }

    void Release()
    {
        if(m_tex)
            m_tex->Release();
    }
    
    void ActivateTexture()
    {
        g_pDevice->SetTexture(0,m_tex);
        if(translucent)
        {
            
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_MODULATE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE); 
            g_pDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE); 
            g_pDevice->SetTextureStageState( 1, D3DTSS_COLOROP,   D3DTOP_DISABLE );
            g_pDevice->SetTextureStageState( 1, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );

            g_pDevice->SetRenderState( D3DRS_SHADEMODE, D3DSHADE_FLAT);

            g_pDevice->SetRenderState( D3DRS_COLORVERTEX, FALSE);
            g_pDevice->SetRenderState( D3DRS_LIGHTING, FALSE);                    

            g_pDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE);
            g_pDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE);
            g_pDevice->SetRenderState( D3DRS_ALPHAREF, m_opacity);
            g_pDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);
        }
        else
        {                
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_MODULATE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
            g_pDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE); 
            g_pDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE); 
            g_pDevice->SetTextureStageState( 1, D3DTSS_COLOROP,   D3DTOP_DISABLE );
            g_pDevice->SetTextureStageState( 1, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );

            g_pDevice->SetRenderState( D3DRS_SHADEMODE, D3DSHADE_FLAT);

            g_pDevice->SetRenderState( D3DRS_COLORVERTEX, FALSE);
            g_pDevice->SetRenderState( D3DRS_LIGHTING, FALSE);                    

            g_pDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE);
            g_pDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE);
        }

    }
};