// CreateButtonDlg.cpp : implementation file
//

#include "stdafx.h"
#include "zui.h"

#pragma warning(disable:4786)
#include <vector>
#include <string>
#include <map>
#include <algorithm>

#include "resource.h"

#include "CreateButtonDlg.h"

extern LPDIRECT3DDEVICE8 g_pDevice;

#include "czuifont.h"
#include "czuitexture.h"
#include "czuiitem.h"

#include "czuimanager.h"
#include "ceditui.h"

#include "FileInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CEditUI *pEditUI;
extern CFileInfoArray fia;

/////////////////////////////////////////////////////////////////////////////
// CCreateButtonDlg dialog


CCreateButtonDlg::CCreateButtonDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCreateButtonDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCreateButtonDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

    m_selectedFontID = -1;
    m_text = "";
}


void CCreateButtonDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCreateButtonDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCreateButtonDlg, CDialog)
	//{{AFX_MSG_MAP(CCreateButtonDlg)
	ON_BN_CLICKED(IDC_BTN_BUTTON_FONT, OnBtnButtonFont)
	ON_EN_CHANGE(IDC_BUTTON_CAPTION, OnChangeButtonCaption)
	ON_CBN_SELCHANGE(IDC_COMBO_BUTTON_DOWN, OnSelchangeComboButtonDown)
	ON_CBN_SELCHANGE(IDC_COMBO_BUTTON_UP, OnSelchangeComboButtonUp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCreateButtonDlg message handlers

void CCreateButtonDlg::OnBtnButtonFont() 
{
CFontDialog cfd;
    cfd.DoModal();
    COLORREF clr = cfd.GetColor();
    int r,g,b;
    r = GetRValue(clr);
    g = GetGValue(clr);
    b = GetBValue(clr);

    CString fontName = cfd.GetFaceName();
    int fontSize = cfd.m_lf.lfHeight;

    int fontStyle = 0;

    if(cfd.IsBold())
        fontStyle |= D3DFONT_BOLD;
    if(cfd.IsItalic())
        fontStyle |= D3DFONT_ITALIC;
    
    CZUIFont *pFont = pEditUI->m_pUIManager->GetFont((LPCTSTR)fontName);
    if(pFont)
    {
        pFont->SetFont(fontName,fontSize,D3DCOLOR_XRGB(r,g,b),fontStyle);
    }
    else
    {
        m_selectedFontID = pEditUI->m_pUIManager->CreateFont(D3DCOLOR_XRGB(r,g,b),
                                        (LPCTSTR)fontName,fontSize,fontStyle);
    }

    GetDlgItem(IDC_BUTTON_FONT)->SetWindowText(fontName);
}

void CCreateButtonDlg::OnChangeButtonCaption() 
{
    CString s;
	GetDlgItem(IDC_BUTTON_CAPTION)->GetWindowText(s);
    m_text = (LPCTSTR)s;
}

void CCreateButtonDlg::OnSelchangeComboButtonDown() 
{
    CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_COMBO_BUTTON_DOWN);
    if(pCombo->GetCurSel() != -1)
    {
        pEditUI->m_ButtonTexIDs[0] =
            pEditUI->m_pUIManager->CreateTexture(
                    fia[pCombo->GetCurSel()].GetFilePath(),
                    pCombo->GetItemData(pCombo->GetCurSel())==1?true:false);	
    }
}

void CCreateButtonDlg::OnSelchangeComboButtonUp() 
{
	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_COMBO_BUTTON_UP);
    if(pCombo->GetCurSel() != -1)
    {
        pEditUI->m_ButtonTexIDs[1] =
            pEditUI->m_pUIManager->CreateTexture(
                    fia[pCombo->GetCurSel()].GetFilePath(),
                    pCombo->GetItemData(pCombo->GetCurSel())==1?true:false);	
    }
}

BOOL CCreateButtonDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    int index = 0;
    //fill list box with textures
    
    for (int i=0;i<fia.GetSize();i++) 
    {
        char buff[255];
        ZeroMemory(buff,255);
        sprintf(buff,(LPCTSTR)fia[i].GetFileName());
        CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_COMBO_BUTTON_DOWN);
        pCB->InsertString(i,buff);
        pCB->SetItemData(index,fia[i].GetFileExt() == ".tga"?1:0);
        pCB = (CComboBox*)GetDlgItem(IDC_COMBO_BUTTON_UP);
        pCB->InsertString(i,buff);
        pCB->SetItemData(index,fia[i].GetFileExt() == ".tga"?1:0);
        index++;
    }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
