// CreateEditboxDlg.cpp : implementation file
//

#include "stdafx.h"
#include "zui.h"
#include "resource.h"
#include "CreateEditboxDlg.h"
#pragma warning(disable:4786)
#include <vector>
#include <string>
#include <map>
#include <algorithm>

extern LPDIRECT3DDEVICE8 g_pDevice;

#include "czuifont.h"
#include "czuitexture.h"
#include "czuiitem.h"

#include "czuimanager.h"
#include "ceditui.h"

#include "FileInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CEditUI *pEditUI;
extern CFileInfoArray fia;

/////////////////////////////////////////////////////////////////////////////
// CCreateEditboxDlg dialog


CCreateEditboxDlg::CCreateEditboxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCreateEditboxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCreateEditboxDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCreateEditboxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCreateEditboxDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCreateEditboxDlg, CDialog)
	//{{AFX_MSG_MAP(CCreateEditboxDlg)
	ON_BN_CLICKED(IDC_BTN_EDITBOX_FONT, OnBtnEditboxFont)
	ON_CBN_SELCHANGE(IDC_COMBO_BACKGROUND_TEXTURE, OnSelchangeComboBackgroundTexture)
	ON_CBN_SELCHANGE(IDC_COMBO_FOREGROUND_TEXTURE, OnSelchangeComboForegroundTexture)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCreateEditboxDlg message handlers

void CCreateEditboxDlg::OnBtnEditboxFont() 
{
	CFontDialog cfd;
    cfd.DoModal();
    COLORREF clr = cfd.GetColor();
    int r,g,b;
    r = GetRValue(clr);
    g = GetGValue(clr);
    b = GetBValue(clr);

    CString fontName = cfd.GetFaceName();
    int fontSize = cfd.m_lf.lfHeight;

    int fontStyle = 0;

    if(cfd.IsBold())
        fontStyle |= D3DFONT_BOLD;
    if(cfd.IsItalic())
        fontStyle |= D3DFONT_ITALIC;
    
    CZUIFont *pFont = pEditUI->m_pUIManager->GetFont((LPCTSTR)fontName);
    if(pFont)
    {
        pFont->SetFont(fontName,fontSize,D3DCOLOR_XRGB(r,g,b),fontStyle);
    }
    else
    {
        pEditUI->m_selectedFontID = pEditUI->m_pUIManager->CreateFont(D3DCOLOR_XRGB(r,g,b),
                                        (LPCTSTR)fontName,fontSize,fontStyle);
    }

    GetDlgItem(IDC_EDITBOX_FONT)->SetWindowText(fontName);
}

BOOL CCreateEditboxDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    int index = 0;
    //fill list box with textures
    
    for (int i=0;i<fia.GetSize();i++) 
    {
        char buff[255];
        ZeroMemory(buff,255);
        sprintf(buff,(LPCTSTR)fia[i].GetFileName());
        CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_COMBO_BACKGROUND_TEXTURE);
        pCB->InsertString(i,buff);
        pCB->SetItemData(index,fia[i].GetFileExt() == ".tga"?1:0);
        pCB = (CComboBox*)GetDlgItem(IDC_COMBO_FOREGROUND_TEXTURE);
        pCB->InsertString(i,buff);
        pCB->SetItemData(index,fia[i].GetFileExt() == ".tga"?1:0);
        index++;
    }
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CCreateEditboxDlg::OnSelchangeComboBackgroundTexture() 
{
	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_COMBO_BACKGROUND_TEXTURE);
    if(pCombo->GetCurSel() != -1)
    {
        pEditUI->m_EditboxTexIDs[0] =
            pEditUI->m_pUIManager->CreateTexture(
                    fia[pCombo->GetCurSel()].GetFilePath(),
                    pCombo->GetItemData(pCombo->GetCurSel())==1?true:false);	
    }
}

void CCreateEditboxDlg::OnSelchangeComboForegroundTexture() 
{
    CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_COMBO_FOREGROUND_TEXTURE);
    if(pCombo->GetCurSel() != -1)
    {
        pEditUI->m_EditboxTexIDs[1] =
            pEditUI->m_pUIManager->CreateTexture(
                    fia[pCombo->GetCurSel()].GetFilePath(),
                    pCombo->GetItemData(pCombo->GetCurSel())==1?true:false);	
    }	
}
