// CreateItemDlg.cpp : implementation file
//

#include "stdafx.h"
#include "zui.h"
#include "resource.h"

#pragma warning(disable:4786)
#include <vector>
#include <string>
#include <map>
#include <algorithm>

extern LPDIRECT3DDEVICE8 g_pDevice;

#include "czuifont.h"
#include "czuitexture.h"
#include "czuiitem.h"

#include "czuimanager.h"
#include "ceditui.h"


#include "CreateItemDlg.h"


#include "FileInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CEditUI *pEditUI;

/////////////////////////////////////////////////////////////////////////////
// CCreateItemDlg dialog


CCreateItemDlg::CCreateItemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCreateItemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCreateItemDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCreateItemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCreateItemDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCreateItemDlg, CDialog)
	//{{AFX_MSG_MAP(CCreateItemDlg)
	ON_BN_CLICKED(IDC_BTN_CREATE_BUTTON, OnBtnCreateButton)
	ON_BN_CLICKED(IDC_BTN_DELETE_BUTTON, OnBtnDeleteButton)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

extern CFileInfoArray fia;

/////////////////////////////////////////////////////////////////////////////
// CCreateItemDlg message handlers
LRESULT CCreateItemDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

    switch(message)
    {
        case WM_INITDIALOG:
            {

                //fill list box with textures
                fia.AddDir("maps\\", "*.*", TRUE, 
                    CFileInfoArray::AP_SORTBYNAME | CFileInfoArray::AP_SORTDESCENDING, 
                    FALSE);


                CWnd *pWnd = this;

                m_pCreatePictureDlg = new CCreatePictureDlg(pWnd);
                m_pCreatePictureDlg->Create(IDD_PICTURE_DIALOG,pWnd);

                RECT r;
                m_pCreatePictureDlg->GetClientRect(&r);
                r.top = 0;
                r.top += 45;
                r.bottom+=58;
                r.left += 3;
                //r.right -= 3;
            
                m_pCreatePictureDlg->MoveWindow(&r);
                m_pCreatePictureDlg->ShowWindow(SW_SHOW);


                m_pCreateEditboxDlg = new CCreateEditboxDlg(pWnd);
                m_pCreateEditboxDlg->Create(IDD_EDITBOX_DIALOG,pWnd);

                m_pCreateEditboxDlg->GetClientRect(&r);
                r.top = 0;
                r.top += 45;
                r.bottom+=58;
                r.left += 3;
                //r.right -= 3;
            
                m_pCreateEditboxDlg->MoveWindow(&r);
                m_pCreateEditboxDlg->ShowWindow(SW_HIDE);


                m_pCreateCheckboxDlg = new CCreateCheckboxDlg(pWnd);
                m_pCreateCheckboxDlg->Create(IDD_CHECKBOX_DIALOG,pWnd);

                m_pCreateCheckboxDlg->GetClientRect(&r);
                r.top = 0;
                r.top += 45;
                r.bottom+=58;
                r.left += 3;
                //r.right -= 3;
            
                m_pCreateCheckboxDlg->MoveWindow(&r);
                m_pCreateCheckboxDlg->ShowWindow(SW_HIDE);

                m_pCreateButtonDlg = new CCreateButtonDlg(pWnd);
                m_pCreateButtonDlg->Create(IDD_BUTTON_DIALOG,pWnd);

                m_pCreateButtonDlg->GetClientRect(&r);
                r.top = 0;
                r.top += 45;
                r.bottom+=58;
                r.left += 3;
                //r.right -= 3;
            
                m_pCreateButtonDlg->MoveWindow(&r);
                m_pCreateButtonDlg->ShowWindow(SW_HIDE);


                m_pCreateSliderDlg = new CCreateSliderDlg(pWnd);
                m_pCreateSliderDlg->Create(IDD_SLIDER_DIALOG,pWnd);

                m_pCreateSliderDlg->GetClientRect(&r);
                r.top = 0;
                r.top += 45;
                r.bottom+=58;
                r.left += 3;
                //r.right -= 3;
            
                m_pCreateSliderDlg->MoveWindow(&r);
                m_pCreateSliderDlg->ShowWindow(SW_HIDE);
            }
        break;

        case WM_DESTROY:
        {
            m_pCreatePictureDlg->DestroyWindow();
            delete m_pCreatePictureDlg;

            m_pCreateEditboxDlg->DestroyWindow();
            delete m_pCreateEditboxDlg;

            m_pCreateCheckboxDlg->DestroyWindow();
            delete m_pCreateCheckboxDlg;

            m_pCreateButtonDlg->DestroyWindow();
            delete m_pCreateButtonDlg;

            m_pCreateSliderDlg->DestroyWindow();
            delete m_pCreateSliderDlg;
        }
        break;
    }
    
    
	return CDialog::WindowProc(message, wParam, lParam);
}

void CCreateItemDlg::OnBtnCreateButton() 
{
    if(!pEditUI)
        return;

    pEditUI->selectedItemID = -1;

    pEditUI->creatingType = abs(IDC_RADIO1 - GetCheckedRadioButton(IDC_RADIO1,IDC_RADIO6));


    CZUITexture *pTex = NULL;

    //validate creation is possible
    if(pEditUI->creatingType == ZUI_PICTURE)
    {
        pTex = pEditUI->m_pUIManager->GetTexture(pEditUI->m_selectedTexture);
        if(!pTex)
        {
            MessageBox("Select a texture first.",NULL, MB_OK | MB_ICONINFORMATION);
            return;
        }

    }
    else if(pEditUI->creatingType == ZUI_EDITBOX)
    {
        for(int x=0;x<2;x++)
        {
            pTex = pEditUI->m_pUIManager->GetTexture(pEditUI->m_EditboxTexIDs[x]);
            if(!pTex)
            {
                MessageBox("Select a texture first.",NULL, MB_OK | MB_ICONINFORMATION);
                return;
            }
        }

        CZUIFont *pFont = pEditUI->m_pUIManager->GetFont(pEditUI->m_selectedFontID);
        if(!pFont)
        {
            MessageBox("Select a Font first."," ",MB_OK | MB_ICONINFORMATION );
            return;
        }
    }
    else if(pEditUI->creatingType == ZUI_CHECKBOX)
    {
        for(int x=0;x<6;x++)
        {
            pTex = pEditUI->m_pUIManager->GetTexture(pEditUI->m_CheckboxTexIDs[x]);
            if(!pTex)
            {
                MessageBox("Select a texture first.",NULL, MB_OK | MB_ICONINFORMATION);
                return;
            }
        }
    }
    else if(pEditUI->creatingType == ZUI_BUTTON)
    {
        for(int x=0;x<2;x++)
        {
            pTex = pEditUI->m_pUIManager->GetTexture(pEditUI->m_ButtonTexIDs[x]);
            if(!pTex)
            {
                MessageBox("Select a texture first.",NULL,MB_OK | MB_ICONINFORMATION);
                return;
            }
        }
        CZUIFont *pFont = pEditUI->m_pUIManager->GetFont(m_pCreateButtonDlg->m_selectedFontID);
        if(!pFont)
        {
            MessageBox("Select a Font first."," ",MB_OK | MB_ICONINFORMATION );
            return;
        }
    }
    else if(pEditUI->creatingType == ZUI_SLIDER)
    {
        for(int x=0;x<2;x++)
        {
            pTex = pEditUI->m_pUIManager->GetTexture(pEditUI->m_SliderTexIDs[x]);
            if(!pTex)
            {
                MessageBox("Select a texture first.",NULL,MB_OK | MB_ICONINFORMATION);
                return;
            }
        }
    }
    
    pEditUI->lastRHW -= .001f;

    if(pEditUI->creatingType == ZUI_EDITBOX)
    {
        int itemID = 
        pEditUI->m_pUIManager->CreateItem(0,0,pEditUI->lastRHW ,
                                          pTex->m_width,pTex->m_height,
                                          pEditUI->m_selectedTexture,
                                          pEditUI->creatingType,
                                          pEditUI->m_EditboxTexIDs);

        CZUIEditBox *pEdit = static_cast<CZUIEditBox*>
                            (pEditUI->m_pUIManager->GetItem(itemID));
        pEdit->m_fontID = pEditUI->m_selectedFontID;
    }
    else if(pEditUI->creatingType == ZUI_CHECKBOX)
    {
        int itemID = 
        pEditUI->m_pUIManager->CreateItem(0,0,pEditUI->lastRHW ,
                                          pTex->m_width,pTex->m_height,
                                          pEditUI->m_selectedTexture,
                                          pEditUI->creatingType,
                                          pEditUI->m_CheckboxTexIDs);
    }
    else if(pEditUI->creatingType == ZUI_PICTURE)
    {
        int itemID = 
        pEditUI->m_pUIManager->CreateItem(0,0,pEditUI->lastRHW ,
                                          pTex->m_width,pTex->m_height,
                                          pEditUI->m_selectedTexture,
                                          pEditUI->creatingType);
    }
    else if(pEditUI->creatingType == ZUI_BUTTON)
    {
        int itemID = 
            pEditUI->m_pUIManager->CreateItem(0,0,pEditUI->lastRHW,
                                              pTex->m_width,pTex->m_height,
                                              pEditUI->m_selectedTexture,
                                              pEditUI->creatingType,
                                              pEditUI->m_ButtonTexIDs);

        CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(itemID);
        if(pItem->IsA(ZUI_BUTTON))
        {
            CZUIButton *pButton = static_cast<CZUIButton*>(
                        pEditUI->m_pUIManager->GetItem(itemID));

            pButton->m_fontID = m_pCreateButtonDlg->m_selectedFontID;
            pButton->m_text = (LPCTSTR)m_pCreateButtonDlg->m_text.c_str();
        }        
    }
    else if(pEditUI->creatingType == ZUI_SLIDER)
    {

        pTex = pEditUI->m_pUIManager->GetTexture(pEditUI->m_SliderTexIDs[0]);

        int itemID = 
            pEditUI->m_pUIManager->CreateItem(0,0,pEditUI->lastRHW,
                                              pTex->m_width,pTex->m_height,
                                              pEditUI->m_selectedTexture,
                                              pEditUI->creatingType,
                                              pEditUI->m_SliderTexIDs);

        CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(itemID);
        if(pItem->IsA(ZUI_SLIDER))
        {
            CZUISlider *pSlider = static_cast<CZUISlider*>(
                        pEditUI->m_pUIManager->GetItem(itemID));

            pSlider->sliderMin = m_pCreateSliderDlg->m_iSliderMin;
            pSlider->sliderMax = m_pCreateSliderDlg->m_iSliderMax;
            pSlider->sliderPos = m_pCreateSliderDlg->m_iSliderPos;

            CZUITexture *pTex2 = pEditUI->m_pUIManager->GetTexture(pEditUI->m_SliderTexIDs[1]);

            pSlider->sliderWidth = pTex2->m_width;
            pSlider->sliderHeight = pTex2->m_height;
        }
    }

    pEditUI->m_pUIManager->SortItems();
}

void CCreateItemDlg::OnBtnDeleteButton() 
{
	 pEditUI->DeleteSelected();
}


void CCreateItemDlg::OnOK()
{
    
}


void CCreateItemDlg::OnRadio1() 
{
    m_pCreatePictureDlg->GetDlgItem(IDC_TEXTURE_LIST)->EnableWindow(TRUE);
    m_pCreatePictureDlg->ShowWindow(SW_SHOW);

    m_pCreateEditboxDlg->ShowWindow(SW_HIDE);
    m_pCreateCheckboxDlg->ShowWindow(SW_HIDE);
    m_pCreateButtonDlg->ShowWindow(SW_HIDE);
    m_pCreateSliderDlg->ShowWindow(SW_HIDE);
}

void CCreateItemDlg::OnRadio2() 
{
    m_pCreatePictureDlg->ShowWindow(SW_HIDE);
    m_pCreateCheckboxDlg->ShowWindow(SW_HIDE);
    m_pCreateEditboxDlg->ShowWindow(SW_SHOW);
    m_pCreateButtonDlg->ShowWindow(SW_HIDE);
    m_pCreateSliderDlg->ShowWindow(SW_HIDE);
}

void CCreateItemDlg::OnRadio3() 
{
	m_pCreatePictureDlg->ShowWindow(SW_HIDE);
    m_pCreateEditboxDlg->ShowWindow(SW_HIDE);
    m_pCreateCheckboxDlg->ShowWindow(SW_SHOW);
    m_pCreateButtonDlg->ShowWindow(SW_HIDE);
    m_pCreateSliderDlg->ShowWindow(SW_HIDE);
}

void CCreateItemDlg::OnRadio4() 
{
	m_pCreatePictureDlg->ShowWindow(SW_HIDE);
    m_pCreateEditboxDlg->ShowWindow(SW_HIDE);
    m_pCreateCheckboxDlg->ShowWindow(SW_HIDE);
    m_pCreateButtonDlg->ShowWindow(SW_HIDE);
    m_pCreateSliderDlg->ShowWindow(SW_HIDE);
}

void CCreateItemDlg::OnRadio5() 
{
    m_pCreatePictureDlg->ShowWindow(SW_HIDE);
    m_pCreateEditboxDlg->ShowWindow(SW_HIDE);
    m_pCreateCheckboxDlg->ShowWindow(SW_HIDE);
	m_pCreateButtonDlg->ShowWindow(SW_SHOW);
    m_pCreateSliderDlg->ShowWindow(SW_HIDE);
}

void CCreateItemDlg::OnRadio6() 
{
    m_pCreatePictureDlg->ShowWindow(SW_HIDE);
    m_pCreateEditboxDlg->ShowWindow(SW_HIDE);
    m_pCreateCheckboxDlg->ShowWindow(SW_HIDE);
	m_pCreateButtonDlg->ShowWindow(SW_HIDE);
    m_pCreateSliderDlg->ShowWindow(SW_SHOW);
}
