// CreateSliderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "zui.h"
#include "resource.h"
#include "CreateSliderDlg.h"

#pragma warning(disable:4786)
#include <vector>
#include <string>
#include <map>
#include <algorithm>

extern LPDIRECT3DDEVICE8 g_pDevice;

#include "czuifont.h"
#include "czuitexture.h"
#include "czuiitem.h"

#include "czuimanager.h"
#include "ceditui.h"

#include "FileInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CEditUI *pEditUI;
extern CFileInfoArray fia;


/////////////////////////////////////////////////////////////////////////////
// CCreateSliderDlg dialog


CCreateSliderDlg::CCreateSliderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCreateSliderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCreateSliderDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCreateSliderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCreateSliderDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCreateSliderDlg, CDialog)
	//{{AFX_MSG_MAP(CCreateSliderDlg)
	ON_EN_CHANGE(IDC_SLIDER_MIN, OnChangeSliderMin)
	ON_EN_CHANGE(IDC_SLIDER_MAX, OnChangeSliderMax)
	ON_EN_CHANGE(IDC_SLIDER_INITIAL, OnChangeSliderInitial)
	ON_CBN_SELCHANGE(IDC_COMBO_SLIDER_BACKGROUND, OnSelchangeComboSliderBackground)
	ON_CBN_SELCHANGE(IDC_COMBO_SLIDER_TEX, OnSelchangeComboSliderTex)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCreateSliderDlg message handlers

void CCreateSliderDlg::OnChangeSliderMin() 
{
    m_iSliderMin = GetDlgItemInt(IDC_SLIDER_MIN);
}

void CCreateSliderDlg::OnChangeSliderMax() 
{
    m_iSliderMax = GetDlgItemInt(IDC_SLIDER_MAX);
}

void CCreateSliderDlg::OnChangeSliderInitial() 
{
    m_iSliderPos = GetDlgItemInt(IDC_SLIDER_INITIAL);
}

BOOL CCreateSliderDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
    
    SetDlgItemText(IDC_SLIDER_MIN,"0");
    SetDlgItemText(IDC_SLIDER_MAX,"100");
    SetDlgItemText(IDC_SLIDER_INITIAL,"0");
	

    int index = 0;
    //fill list box with textures
    
    for (int i=0;i<fia.GetSize();i++) 
    {
        char buff[255];
        ZeroMemory(buff,255);
        sprintf(buff,(LPCTSTR)fia[i].GetFileName());
        CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_COMBO_SLIDER_BACKGROUND);
        pCB->InsertString(i,buff);
        pCB->SetItemData(index,fia[i].GetFileExt() == ".tga"?1:0);
        pCB = (CComboBox*)GetDlgItem(IDC_COMBO_SLIDER_TEX);
        pCB->InsertString(i,buff);
        pCB->SetItemData(index,fia[i].GetFileExt() == ".tga"?1:0);
        index++;
    }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCreateSliderDlg::OnSelchangeComboSliderBackground() 
{
    CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_COMBO_SLIDER_BACKGROUND);
    if(pCombo->GetCurSel() != -1)
    {
        pEditUI->m_SliderTexIDs[0] =
            pEditUI->m_pUIManager->CreateTexture(
                    fia[pCombo->GetCurSel()].GetFilePath(),
                    pCombo->GetItemData(pCombo->GetCurSel())==1?true:false);	
    }
}

void CCreateSliderDlg::OnSelchangeComboSliderTex() 
{
	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_COMBO_SLIDER_TEX);
    if(pCombo->GetCurSel() != -1)
    {
        pEditUI->m_SliderTexIDs[1] =
            pEditUI->m_pUIManager->CreateTexture(
                    fia[pCombo->GetCurSel()].GetFilePath(),
                    pCombo->GetItemData(pCombo->GetCurSel())==1?true:false);	
    }
}
