// LoadSaveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "zui.h"
#include "resource.h"

#pragma warning(disable:4786)
#include <vector>
#include <string>
#include <map>
#include <algorithm>

extern LPDIRECT3DDEVICE8 g_pDevice;
#include "czuifont.h"
#include "czuitexture.h"
#include "czuiitem.h"
#include "czuimanager.h"
#include "ceditui.h"

#include "FileInfo.h"
#include "LoadSaveDlg.h"


extern CEditUI *pEditUI;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLoadSaveDlg dialog


CLoadSaveDlg::CLoadSaveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoadSaveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoadSaveDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CLoadSaveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoadSaveDlg)
	DDX_Control(pDX, IDC_SAVE_LIST, m_SaveList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLoadSaveDlg, CDialog)
	//{{AFX_MSG_MAP(CLoadSaveDlg)
	ON_BN_CLICKED(IDC_BTN_SAVE_SAVE, OnBtnSaveSave)
	ON_BN_CLICKED(IDC_BTN_LOAD_SAVE, OnBtnLoadSave)
	ON_BN_CLICKED(IDC_BTN_DEL_SAVE, OnBtnDelSave)
	ON_BN_CLICKED(IDC_BTN_CLEAR_SCENE, OnBtnClearScene)
	ON_LBN_SELCHANGE(IDC_SAVE_LIST, OnSelchangeSaveList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoadSaveDlg message handlers

void CLoadSaveDlg::OnBtnSaveSave() 
{
    CString s,sPath;
    GetDlgItem(IDC_SAVEAS_EDIT)->GetWindowText(s);
    int i = s.FindOneOf(".");
    if(i >= 0)
        sPath = s.Left(i);
    else
        sPath = s;

    if(s.Right(3) != "zui")
        s += ".zui";
    
    s = "savedViews\\" + s;
    
	pEditUI->m_pUIManager->Save(s);

    CListBox *pList = (CListBox*)GetDlgItem(IDC_SAVE_LIST);
    pList->ResetContent();
    
    SetCurrentDirectory("savedViews");
    pList->Dir(0,_T("*.zui"));
    SetCurrentDirectory("..");
}

void CLoadSaveDlg::OnBtnLoadSave() 
{
	CString s;
    CListBox *pList = (CListBox*)GetDlgItem(IDC_SAVE_LIST);
    if(pList->GetCurSel()>=0)
        pList->GetText(pList->GetCurSel(),s);
    else
        return;
    
    s = "savedViews\\" + s;

    if(s.GetLength())
    {
        
        pEditUI->selectedItemID = -1;
        pEditUI->selectedPoint = -1;
        
        pEditUI->m_pUIManager->RemoveAll();
        pEditUI->m_pUIManager->Load(s);
    }
    
    pEditUI->m_pUIManager->SortItems();

    CMenu *pMenu = (CMenu*)GetParent()->GetParent()->GetParent()->GetMenu();
    //set menu to selected width/height
    switch(pEditUI->m_pUIManager->m_virtualHeight)
    {
        case 480:
            pMenu->CheckMenuItem(ID_VSCREEN_640480 ,MF_CHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_800600 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_1024768 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_16001200 ,MF_UNCHECKED);
            break;
        case 600:
            pMenu->CheckMenuItem(ID_VSCREEN_640480 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_800600 ,MF_CHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_1024768 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_16001200 ,MF_UNCHECKED);
            break;
        case 768:
            pMenu->CheckMenuItem(ID_VSCREEN_640480 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_800600 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_1024768 ,MF_CHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_16001200 ,MF_UNCHECKED);
            break;
        case 1200:
            pMenu->CheckMenuItem(ID_VSCREEN_640480 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_800600 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_1024768 ,MF_UNCHECKED);
            pMenu->CheckMenuItem(ID_VSCREEN_16001200 ,MF_CHECKED);
            break;
    }
}

void CLoadSaveDlg::OnBtnDelSave() 
{
    CString s;
    CListBox *pList = (CListBox*)GetDlgItem(IDC_SAVE_LIST);
    if(pList->GetCurSel()>=0)
        pList->GetText(pList->GetCurSel(),s);

    if(!s.GetLength())
        return;

    SetCurrentDirectory("savedViews");
    DeleteFile(s);
    SetCurrentDirectory("..");
    
    int i = pList->FindString(0,s);
    if(i >= 0)
    {
        pList->DeleteString(i);
        pList->ResetContent();
        SetCurrentDirectory("savedViews");
        pList->Dir(0,_T("*.zui"));
        SetCurrentDirectory("..");
    }
}

BOOL CLoadSaveDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

    CListBox *pList = (CListBox*)GetDlgItem(IDC_SAVE_LIST);
    pList->ResetContent();
    SetCurrentDirectory("savedViews");
    pList->Dir(0,_T("*.zui"));
    SetCurrentDirectory("..");
    
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CLoadSaveDlg::OnBtnClearScene() 
{
    pEditUI->selectedItemID = -1;
    pEditUI->selectedPoint = -1;
    pEditUI->m_pUIManager->RemoveAll();	
}

void CLoadSaveDlg::OnSelchangeSaveList() 
{
    CString s;
    CListBox *pList = (CListBox*)GetDlgItem(IDC_SAVE_LIST);
    pList->GetText(pList->GetCurSel(),s);
    GetDlgItem(IDC_SAVEAS_EDIT)->SetWindowText(s);
}
