// ModifyItemDlg.cpp : implementation file
//

#include "stdafx.h"
#include "zui.h"
#include "resource.h"
#pragma warning(disable:4786)
#include <vector>
#include <string>
#include <map>
#include <algorithm>

extern LPDIRECT3DDEVICE8 g_pDevice;
#include "czuifont.h"
#include "czuitexture.h"
#include "czuiitem.h"
#include "czuimanager.h"
#include "ceditui.h"

#include "ModifyItemDlg.h"

extern CEditUI *pEditUI;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CModifyItemDlg dialog


CModifyItemDlg::CModifyItemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CModifyItemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CModifyItemDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CModifyItemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModifyItemDlg)
	DDX_Control(pDX, IDC_SPIN1, m_RHWSpinner);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CModifyItemDlg, CDialog)
	//{{AFX_MSG_MAP(CModifyItemDlg)
	ON_EN_CHANGE(IDC_MODIFY_SELECTED_ID, OnChangeModifySelectedId)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_BTN_SEND_TO_BACK, OnBtnSendToBack)
	ON_BN_CLICKED(IDC_BTN_BRING_TO_FRONT, OnBtnBringToFront)
	ON_BN_CLICKED(IDC_BTN_CLONE_ITEM, OnBtnCloneItem)
	ON_BN_CLICKED(IDC_BTN_MOD_DELETE, OnBtnModDelete)
	ON_EN_CHANGE(IDC_MODIFY_NAME, OnChangeModifyName)
	ON_EN_SETFOCUS(IDC_MODIFY_NAME, OnSetfocusModifyName)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_CALLBACK_EVENT, OnCallbackEvent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModifyItemDlg message handlers

void CModifyItemDlg::OnChangeModifySelectedId() 
{
    CString s;
    GetDlgItem(IDC_MODIFY_SELECTED_ID)->GetWindowText(s);
    CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(atoi(s));
    if(pItem)
    {
        s.Format("%.8f",pItem->z);
        GetDlgItem(IDC_EDIT_RHW)->SetWindowText(s);
    }
}




BOOL CModifyItemDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

    CSpinButtonCtrl *pSpin = (CSpinButtonCtrl *)GetDlgItem(IDC_SPIN1);
    pSpin->SetRange(-10000000,10000000);

    CSliderCtrl *pScroll = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_TRANSLUCENCY);
    pScroll->SetRange(0,255);
    
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CModifyItemDlg::OnBtnSendToBack() 
{
	CString s;
    GetDlgItem(IDC_MODIFY_SELECTED_ID)->GetWindowText(s);
    CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(atoi(s));
    if(pItem)
    {
        float closest = 0.0f;

        std::vector<CZUIItem *>::iterator iter = pEditUI->m_pUIManager->m_ItemList.begin();
        for(; iter != pEditUI->m_pUIManager->m_ItemList.end(); iter++)
        {
            if((*iter)->z > closest)
            {
                closest = (*iter)->z;
            }
        }

        pItem->z = closest + .0001;
        pItem->Initialize();
    }

    pEditUI->m_pUIManager->SortItems();
}

void CModifyItemDlg::OnBtnBringToFront() 
{
    CString s;
    GetDlgItem(IDC_MODIFY_SELECTED_ID)->GetWindowText(s);
    CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(atoi(s));
    if(pItem)
    {
        float closest = 100000.0f;

        std::vector<CZUIItem *>::iterator iter = pEditUI->m_pUIManager->m_ItemList.begin();
        for(; iter != pEditUI->m_pUIManager->m_ItemList.end(); iter++)
        {
            if((*iter)->z < closest)
            {
                closest = (*iter)->z;
            }
        }

        pItem->z = closest - .0001;
        pItem->Initialize();
    }

    pEditUI->m_pUIManager->SortItems();
}

void CModifyItemDlg::OnBtnCloneItem() 
{
    if(pEditUI->selectedItemID!= -1)
    {
        CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(pEditUI->selectedItemID);
        if(pItem)
        {
            int newItemID = -1;

            if(pItem->IsA(ZUI_PICTURE))
            {
                newItemID = pEditUI->m_pUIManager->CreateItem(pItem->x,pItem->y,pItem->z - .0001,
                                               pItem->width,pItem->height,pItem->m_texID,
                                               pItem->m_type);
            }
            else if(pItem->IsA(ZUI_EDITBOX))
            {
                CZUIEditBox *pEdit = static_cast<CZUIEditBox*>(pItem);

                int iEdit = 
                pEditUI->m_pUIManager->CreateItem(pItem->x,pItem->y,pItem->z - .0001,
                                               pItem->width,pItem->height,pItem->m_texID,
                                               pItem->m_type,(int*)pEdit->m_texIDs);

                newItemID = iEdit;
                CZUIEditBox *pNewEdit = static_cast<CZUIEditBox*>(pEditUI->
                                                m_pUIManager->GetItem(iEdit));
                pNewEdit->m_fontID = pEdit->m_fontID;
            }
            else if(pItem->IsA(ZUI_CHECKBOX))
            {
                CZUICheckBox *pCheck = static_cast<CZUICheckBox*>(pItem);

                newItemID = pEditUI->m_pUIManager->CreateItem(pItem->x,pItem->y,pItem->z - .0001,
                                               pItem->width,pItem->height,pItem->m_texID,
                                               pItem->m_type,(int*)pCheck->m_texIDs);
            }
            else if(pItem->IsA(ZUI_BUTTON))
            {
                CZUIButton *pButton = static_cast<CZUIButton*>(pItem);

                newItemID = pEditUI->m_pUIManager->CreateItem(pItem->x,pItem->y,pItem->z - .0001,
                                               pItem->width,pItem->height,pItem->m_texID,
                                               pItem->m_type,(int*)pButton->m_texIDs);

                CZUIButton *pNewButton = static_cast<CZUIButton*>(pEditUI->
                                                m_pUIManager->GetItem(newItemID));
                pNewButton->m_fontID = pButton->m_fontID;
                pNewButton->m_text = pButton->m_text;
            }
            CZUIItem *pNewItem = pEditUI->m_pUIManager->GetItem(newItemID);
            if(pNewItem)
            {
                pNewItem->m_iTranslucency = pItem->m_iTranslucency;
                pNewItem->m_bCallbackEvent = pItem->m_bCallbackEvent;
            }
        }
    }
}

void CModifyItemDlg::OnBtnModDelete() 
{
    pEditUI->DeleteSelected();	
}

void CModifyItemDlg::OnChangeModifyName() 
{
    if(pEditUI->selectedItemID== -1)
        return;
    CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(pEditUI->selectedItemID);
    if(pItem)
    {
        CString s;
        GetDlgItemText(IDC_MODIFY_NAME,s);
        pItem->m_name = (LPCTSTR)s;
    }
}

void CModifyItemDlg::OnSetfocusModifyName() 
{
   CString s;
   GetDlgItemText(IDC_MODIFY_NAME,s);
   CEdit *pEdit = (CEdit *)GetDlgItem(IDC_MODIFY_NAME);
   pEdit->SetSel(s.GetLength(),s.GetLength());
}


void CModifyItemDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    switch(pScrollBar->GetDlgCtrlID())
    {
    case IDC_SPIN1:
        {
            static int lastVScrollPos = 0;
            int change = lastVScrollPos - nPos;
            CString s;
            GetDlgItem(IDC_MODIFY_SELECTED_ID)->GetWindowText(s);
            CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(atoi(s));
            if(pItem)
            {
                pItem->z += (.0001f * float(1*change));
                s.Format("%.8f",pItem->z);
                pItem->Initialize();
                GetDlgItem(IDC_EDIT_RHW)->SetWindowText(s);
            }
            lastVScrollPos = nPos;

            pEditUI->m_pUIManager->SortItems();
        }
        break;
    }
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CModifyItemDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{	
    switch(pScrollBar->GetDlgCtrlID())
    {
    case IDC_SLIDER_TRANSLUCENCY:
        {
            CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(pEditUI->selectedItemID);
            if(pItem)
            {
                CSliderCtrl *pScroll = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_TRANSLUCENCY);
                CWnd *pEdit = GetDlgItem(IDC_MODIFY_TRANSLUCENCY);
    
                int i = pScroll->GetPos();
                pItem->m_iTranslucency = i;

                for(int x=0;x<4;x++)
                {
                    pItem->m_pVerts[x].color = D3DCOLOR_ARGB(pItem->m_iTranslucency,255,255,255);
                }


                CString s;
                s.Format("%d",i);
                pEdit->SetWindowText(s);
            }
        }
    }

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CModifyItemDlg::OnCallbackEvent() 
{
    CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(pEditUI->selectedItemID);
    if(pItem)
    {
        pItem->m_bCallbackEvent = IsDlgButtonChecked(IDC_CALLBACK_EVENT) == 1? true:false;
    }
}
