// TestItemDlg.cpp : implementation file
//

#include "stdafx.h"
#include "zui.h"
#include "resource.h"

#pragma warning(disable:4786)
#include <vector>
#include <string>
#include <map>
#include <algorithm>

extern LPDIRECT3DDEVICE8 g_pDevice;
#include "czuifont.h"
#include "czuitexture.h"
#include "czuiitem.h"
#include "czuimanager.h"
#include "ceditui.h"

#include "TestItemDlg.h"

extern CEditUI *pEditUI;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestItemDlg dialog


CTestItemDlg::CTestItemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestItemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestItemDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CTestItemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestItemDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTestItemDlg, CDialog)
	//{{AFX_MSG_MAP(CTestItemDlg)
	ON_BN_CLICKED(IDC_CAPTURE_EVENTS, OnSimulateEvents)
	ON_EN_CHANGE(IDC_EDIT_OPACITY, OnChangeEditOpacity)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_EDITBOX_TEST, OnChangeEditboxTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestItemDlg message handlers

void CTestItemDlg::OnSimulateEvents() 
{
    if(IsDlgButtonChecked(IDC_CAPTURE_EVENTS))
    {
        pEditUI->m_CaptureEvents = 1;
    }
    else
    {
        pEditUI->m_CaptureEvents = 0;
    }
}

void CTestItemDlg::OnChangeEditOpacity() 
{
    CString s;
    CWnd *pEdit = GetDlgItem(IDC_EDIT_OPACITY);
    pEdit->GetWindowText(s);

    if(s.GetLength() == 0)
        return;
    
    for(int x=0;x<s.GetLength();x++)
    {
        if(!isalnum(s[x]))
        {
            return;
        }
    }
    int iOpacity = atoi((LPCTSTR)s);

    s.Format("%d",iOpacity);
    //pEdit->SetWindowText(sout);

    pEditUI->m_pUIManager->m_opacity = iOpacity;
}

void CTestItemDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    CSliderCtrl *pScroll = (CSliderCtrl*)GetDlgItem(IDC_OPACITY_SLIDER);
    CWnd *pEdit = GetDlgItem(IDC_EDIT_OPACITY);
    
    int i = pScroll->GetPos();

    CString s;
    s.Format("%d",i);
    pEdit->SetWindowText(s);
    
    
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

BOOL CTestItemDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

    CSliderCtrl *pSlider = (CSliderCtrl*)GetDlgItem(IDC_OPACITY_SLIDER);
    pSlider->SetRange(0,255);
   
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTestItemDlg::OnChangeEditboxTest() 
{
    if(pEditUI->m_CaptureItem != -1)
    {
        CZUIItem *pItem = pEditUI->m_pUIManager->GetItem(pEditUI->m_CaptureItem );
        if(pItem)
        {
            if(pItem->IsA(ZUI_EDITBOX))
            {
                CZUIEditBox *pEdit = static_cast<CZUIEditBox*>(pItem);

                CString s;
                GetDlgItem(IDC_EDITBOX_TEST)->GetWindowText(s);
                
                pEdit->m_text = (LPCTSTR)s;

                if(pEdit->m_text.length() > 0)
                {
                    CZUIFont *pFont = pEditUI->m_pUIManager->GetFont(pEdit->m_fontID);
                    if(pFont)
                    {
                        SIZE xpos;
                        pFont->m_pFont->GetTextExtent((char*)pEdit->m_text.c_str(),&xpos);
                        pEdit->SetSel(xpos.cx);
                    }
                }
                else
                {
                    pEdit->SetSel(-1);
                }
            }
        }
    }
	
}
