//-----------------------------------------------------------------------------
// File: ZUI.cpp
//
// Desc: DirectX MFC dialog application created by the DirectX AppWizard
//-----------------------------------------------------------------------------
#define STRICT
#define DIRECTINPUT_VERSION 0x0800
#include "stdafx.h"
#include "resource.h"
#include "ZUI.h"
#include <pr.h>
#include "FileInfo.h"

LPDIRECT3DDEVICE8 g_pDevice;

#pragma warning(disable:4786)
#include <vector>
#include <string>
#include <map>
#include <algorithm>

#include "czuifont.h"
#include "czuitexture.h"
#include "czuiitem.h"
#include "czuimanager.h"
#include "ceditui.h"

#include "CreateItemDlg.h"
#include "ModifyItemDlg.h"
#include "LoadSaveDlg.h"
#include "TestItemDlg.h"


GUID g_guidApp = { 0x1679e22c, 0xa04c, 0x4c7b, { 0x9f, 0x15, 0x2d, 0x83, 0x40, 0x24, 0x17, 0xc0 } };



std::vector<std::string> debugStringList;


//CZUIManager *g_pUIManager;

CFileInfoArray fia;
CFileInfoArray fiaCheckBoxes;

CEditUI *pEditUI;



TCHAR*          g_strAppTitle       = _T( "ZUI" );
CApp            g_App;
HINSTANCE       g_hInst = NULL;
CAppForm*       g_AppFormView = NULL;


PR_VIEWPORT viewport;                  /* Our viewport structure */
PR_CAMERA *camera;                     /* One camera */
PR_OBJECT *object_shape;               /* The shape loaded */
PR_ENTITY *entity;                     /* A single entity of the shape */
PR_LIGHTLIST userlights;               /* Holds a list of lights */
PR_FONT *Font_Impact;






//-----------------------------------------------------------------------------
// The MFC macros are all listed here
//-----------------------------------------------------------------------------
IMPLEMENT_DYNCREATE( CAppDoc,      CDocument )
IMPLEMENT_DYNCREATE( CAppFrameWnd, CFrameWnd )
IMPLEMENT_DYNCREATE( CAppForm,     CFormView )




BEGIN_MESSAGE_MAP( CApp, CWinApp )
    //{{AFX_MSG_MAP(CApp)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()




BEGIN_MESSAGE_MAP( CAppForm, CFormView )
    //{{AFX_MSG_MAP(CAppForm)
    ON_COMMAND(    IDC_VIEWFULLSCREEN, OnToggleFullScreen )
    ON_BN_CLICKED(IDC_CHANGEDEVICE, OnChangeDevice)
	ON_WM_PAINT()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab1)
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




BEGIN_MESSAGE_MAP(CAppDoc, CDocument)
    //{{AFX_MSG_MAP(CAppDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




BEGIN_MESSAGE_MAP(CAppFrameWnd, CFrameWnd)
    //{{AFX_MSG_MAP(CAppFrameWnd)
	ON_WM_SIZE()
	ON_COMMAND(ID_VSCREEN_1024768, OnVscreen1024768)
  	ON_COMMAND(ID_VSCREEN_16001200, OnVscreen16001200)
	ON_COMMAND(ID_VSCREEN_640480, OnVscreen640480)
	ON_COMMAND(ID_VSCREEN_800600, OnVscreen800600)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




//-----------------------------------------------------------------------------
// Name: CAppForm()
// Desc: Constructor for the dialog resource form
//-----------------------------------------------------------------------------
CAppForm::CAppForm()
         :CFormView( IDD_FORMVIEW )
{
    //{{AFX_DATA_INIT(CAppForm)
	//}}AFX_DATA_INIT

    g_AppFormView          = this;
    m_hwndRenderWindow     = NULL;
    m_hwndRenderFullScreen = NULL;
    m_hWndTopLevelParent   = NULL;

    // Override some CD3DApplication defaults:
    m_dwCreationWidth           = 1024;
    m_dwCreationHeight          = 768;
    m_strWindowTitle            = TEXT( "ZUI" );
    m_bUseDepthBuffer           = TRUE;

    m_bLoadingApp               = TRUE;
    m_pVB                       = NULL;
    m_pDIConfigSurface          = NULL;

    // Read settings from registry
    ReadSettings();
}


PR_DWORD device = DEVICE_D3D;
void InitializeDevices (void)
{
  if ((device == DEVICE_D3D) || (device == DEVICE_ANY))
    device = PR_DetectD3D ();   /* Attempt to find the device */
  
  if (device == DEVICE_D3D)
    {
     PR_InitializeD3D ();
    }
}


void ChooseDevice (void)
{
  device = DEVICE_D3D;
}


//-----------------------------------------------------------------------------
// Name: CAppForm::OneTimeSceneInit()
// Desc: Called during initial app startup, this function performs all the
//       permanent initialization.
//-----------------------------------------------------------------------------
HRESULT CAppForm::OneTimeSceneInit()
{
    m_bLoadingApp = FALSE;
    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: ReadSettings()
// Desc: Read the app settings from the registry
//-----------------------------------------------------------------------------
VOID CAppForm::ReadSettings()
{
    HKEY hkey;
    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, DXAPP_KEY, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
        // TODO: change as needed

        // Read the stored window width/height.  This is just an example,
        // of how to use DXUtil_Read*() functions.
        DXUtil_ReadIntRegKey( hkey, TEXT("Width"), &m_dwCreationWidth, m_dwCreationWidth );
        DXUtil_ReadIntRegKey( hkey, TEXT("Height"), &m_dwCreationHeight, m_dwCreationHeight );

        RegCloseKey( hkey );
    }
}




//-----------------------------------------------------------------------------
// Name: WriteSettings()
// Desc: Write the app settings to the registry
//-----------------------------------------------------------------------------
VOID CAppForm::WriteSettings()
{
    HKEY hkey;
    DWORD dwType = REG_DWORD;
    DWORD dwLength = sizeof(DWORD);

    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, DXAPP_KEY, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
        // TODO: change as needed

        // Write the window width/height.  This is just an example,
        // of how to use DXUtil_Write*() functions.
        DXUtil_WriteIntRegKey( hkey, TEXT("Width"), m_rcWindowClient.right );
        DXUtil_WriteIntRegKey( hkey, TEXT("Height"), m_rcWindowClient.bottom );

        RegCloseKey( hkey );
    }
}


//-----------------------------------------------------------------------------
// Name: ConfirmDevice()
// Desc: Called during device initialization, this code checks the display device
//       for some minimum set of capabilities
//-----------------------------------------------------------------------------
HRESULT CAppForm::ConfirmDevice( D3DCAPS8* pCaps, DWORD dwBehavior,
                                          D3DFORMAT Format )
{
    BOOL bCapsAcceptable;

    // TODO: Perform checks to see if these display caps are acceptable.
    bCapsAcceptable = TRUE;

    if( bCapsAcceptable )         
        return S_OK;
    else
        return E_FAIL;
}




PR_DWORD BLACK;
//-----------------------------------------------------------------------------
// Name: CAppForm::InitDeviceObjects()
// Desc: Initialize scene objects.
//-----------------------------------------------------------------------------
HRESULT CAppForm::InitDeviceObjects()
{
   

        static int inited = 0;
    if(inited == 0)
    {
        // TODO: perform one time initialization

        PR_Initialize (1000);                /* Maximum 1000 triangles per frame */
        PR_Settings.UseWindowed = 1;
        InitializeDevices();
        
        PR_AllocMaterials (32);              /* Allocate the materials, */
        PR_AllocTextures (32);

        PR_SetWindow(this->m_hwndRenderWindow,g_hInst);

        PR_SetMode (1024, 768, 60);

        RECT r;
        ::GetWindowRect(this->m_hwndRenderWindow,&r);
        PR_OpenViewport (&viewport, 0, 0,r.right-r.left,r.bottom -r.top, VIEW_PLAIN);
        PR_SetViewport (&viewport);          /* Open a full screen viewport */

        PR_SetD3DPipeline(1);
        PR_Globals.EnableVShaders = 1;
        //PR_Globals.EnablePShaders = 1;
        
        PR_Settings.Use32Bit = 1;
        PR_Settings.HardwareMipmaps = -1;
        
        SetCurrentDirectory("testData");
        /* Load the object */
        object_shape = PR_LoadPRO ("cube.pro", LOAD_NORMAL);
        SetCurrentDirectory("..");
        if (object_shape == NULL)
        PR_FatalError ("Cannot open data file", "SimpleObject");
        PR_REAL cenx, ceny, cenz;
        PR_CenterObject (object_shape, &cenx, &ceny, &cenz);

        /* Create the main entity */
        entity = PR_CreateEntity (object_shape, "TEST ENTITY");
        
        camera = PR_AllocCamera ();          /* Initialize the camera */
        PR_InitializeCamera (camera);
        PR_PositionCameraSource (camera, 0, 0, 400);
        PR_PositionCameraTarget (camera, 0, 0, 0);
        PR_SetCameraMode (camera, CAMFLAG_AIM_TARGET); 
        PR_SetActiveCamera (camera);

        PR_OpenScreen (PR_BACKBUFFER);

        /* Initialize the light */
        PR_AllocLights (&PR_Globals.scenelights, 1);
        PR_AllocLights (&userlights, 1);
        PR_SetLightPosition (&userlights, 0, 0, 0, 400);
        PR_SetLightOn (&userlights, 0);
        PR_SetLightType (&userlights, 0, DIRECTIONAL_LIGHT);
        PR_SetLightColor (&userlights, 0, 1.0, 1.0, 1.0);
        PR_SetLightStrength (&userlights, 0, 1.0);
        userlights.NumLights = 1;     /* This sets how many lights are actually used */


        BLACK = PRGFX_MakeColor (0, 0, 0);

        //installkbd ();
        PR_InitTimer (60);

        PRGFX_SetTextForeground (PRGFX_MakeColor (255, 255, 255));
        PRGFX_SetTextBackground (BLACK);

        PRGFX_SetTextTransparent (TEXTFG);

        SetCurrentDirectory("fonts");
        Font_Impact      = PR_LoadFont ("impact.pft");
        SetCurrentDirectory("..");
        
        pEditUI = new CEditUI;

        g_pDevice = PR_Globals.PR_Direct3DDevice;

        inited = 1;
    }



    //init tab control
    InitTabControl();


    return S_OK;
}


void PrintText(long x,long y,char *text)
{
    PR_SetFontSpacing (1);
    PR_SetFontDepth (PR_Globals.PR_CurrentCamera->nearclip + 1);

    PR_SetFont (Font_Impact);
    PR_SetFontScale (.5);
    PR_SetFontColor (255, 255, 0);
    PR_FontPrint (x, y,(char*) text);
}



//-----------------------------------------------------------------------------
// Name: CAppForm::RestoreDeviceObjects()
// Desc: Initialize scene objects.
//-----------------------------------------------------------------------------
HRESULT CAppForm::RestoreDeviceObjects()
{
    

    return S_OK;
}



//-----------------------------------------------------------------------------
// Name: CAppForm::FrameMove()
// Desc: Called once per frame, the call is the entry point for animating
//       the scene.
//-----------------------------------------------------------------------------
HRESULT CAppForm::FrameMove()
{
    return S_OK;
}







//-----------------------------------------------------------------------------
// Name: CAppForm::Render()
// Desc: Called once per frame, the call is the entry point for 3d
//       rendering. This function sets up render states, clears the
//       viewport, and renders the scene.
//-----------------------------------------------------------------------------
HRESULT CAppForm::Render()
{



    PR_REAL move_count;
    move_count = PR_GetTicks ();

    PR_OpenScreen (PR_BACKBUFFER);

    PRGFX_SetColor (BLACK);
    PR_ClearViewport (&PR_Globals.active_viewport);

    PR_NewFrame ();                   /* Begin a new frame */

    PR_TransformLights (&userlights);
    
    PR_SetActiveCamera(camera);
    
    PR_Globals.last_method = -1;
    
    PR_RotateEntity (entity,  cos(move_count)*.01,
                      cos(move_count)*(3.14159/180.)+sin(move_count)*.02f,
                      move_count*.01);  
    PR_TransformEntity (entity);      /* Transform the entity */
    PR_RenderEntity (entity);         /* Render the entity */


    
    pEditUI->Render();

    char buff[10];
    sprintf(buff,"fps %.2f",m_fFPS);
    PrintText(2,0,buff);

    
    
    PR_RenderFrame ();                /* Draw the scene */
       
    

    PR_Flip (1);  

    
    

    return S_OK;
}





//-----------------------------------------------------------------------------
// Name: Pause()
// Desc: Called in to toggle the pause state of the app.
//-----------------------------------------------------------------------------
VOID CAppForm::Pause( BOOL bPause )
{
    CD3DApplication::Pause( bPause );
}




//-----------------------------------------------------------------------------
// Name: DoDataExchange()
// Desc: DDX/DDV support
//-----------------------------------------------------------------------------
void CAppForm::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAppForm)
	DDX_Control(pDX, IDC_TAB1, m_TabControl);
	//}}AFX_DATA_MAP
}




//-----------------------------------------------------------------------------
// Name: WindowProc()
// Desc: 
//-----------------------------------------------------------------------------

CCreateItemDlg *pCreateItemDlg = NULL;
CModifyItemDlg *pModifyItemDlg = NULL;
CLoadSaveDlg *pLoadSaveDlg = NULL;
CTestItemDlg *pTestItemDlg = NULL;

LRESULT CAppForm::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
    switch( message )
    {

        case WM_INITDIALOG:
        {
            CWnd *pWnd = GetDlgItem(IDC_TAB1);

            pCreateItemDlg = new CCreateItemDlg(pWnd);
            pCreateItemDlg->Create(IDD_CREATE_DIALOG,pWnd);
            RECT r;
            pCreateItemDlg->GetClientRect(&r);
            r.top = 0;
            r.top += 25;
            r.bottom+=30;
            r.left += 3;
            //r.right -= 10;
            
            pCreateItemDlg->MoveWindow(&r);
            pCreateItemDlg->ShowWindow(SW_SHOW);

            pCreateItemDlg->CheckDlgButton(IDC_RADIO1,1);
            pCreateItemDlg->m_pCreatePictureDlg->GetDlgItem(IDC_TEXTURE_LIST)->SetFocus();
            
            pModifyItemDlg = new CModifyItemDlg;
            pModifyItemDlg->Create(IDD_MODIFY_DIALOG,pWnd);
            pModifyItemDlg->GetClientRect(&r);
            r.top = 0;
            r.top += 25;
            r.bottom+=30;
            r.left += 3;
            
            pModifyItemDlg->MoveWindow(&r);
            pModifyItemDlg->ShowWindow(SW_HIDE);

            pLoadSaveDlg = new CLoadSaveDlg;
            pLoadSaveDlg->Create(IDD_LOADSAVE_DIALOG,pWnd);
            pLoadSaveDlg->GetClientRect(&r);
            r.top = 0;
            r.top += 25;
            r.bottom+=30;
            r.left += 3;

            pLoadSaveDlg->MoveWindow(&r);
            pLoadSaveDlg->ShowWindow(SW_HIDE);

            pTestItemDlg = new CTestItemDlg;
            pTestItemDlg->Create(IDD_TEST_DIALOG,pWnd);
            pTestItemDlg->GetClientRect(&r);
            r.top = 0;
            r.top += 25;
            r.bottom+=30;
            r.left += 3;

            pTestItemDlg->MoveWindow(&r);
            pTestItemDlg->ShowWindow(SW_HIDE);
        }
        break;

        case WM_MOUSEMOVE:
            {
                int x = LOWORD(lParam);
                int y = HIWORD(lParam);
                pEditUI->MouseMove(x,y);
            }
            break;

        case WM_RBUTTONDOWN:
            {
                int x = LOWORD(lParam);
                int y = HIWORD(lParam);
                pEditUI->MouseClick(2,x,y);

                CString s;
                s.Format("%d",pEditUI->selectedItemID);
                pModifyItemDlg->GetDlgItem(IDC_MODIFY_SELECTED_ID)->SetWindowText(s);
            }
            break;

        case WM_LBUTTONDOWN:
            {
                int x = LOWORD(lParam);
                int y = HIWORD(lParam);
                pEditUI->MouseClick(1,x,y);

                CString s;
                s.Format("%d",pEditUI->selectedItemID);
                pModifyItemDlg->GetDlgItem(IDC_MODIFY_SELECTED_ID)->SetWindowText(s);
            }
            break;
        case WM_LBUTTONUP:
            {
                pEditUI->MouseUp(1,LOWORD(lParam),HIWORD(lParam));
            }
            break;
        case WM_DESTROY:
        {
            SaveSettings();
            
            pCreateItemDlg->DestroyWindow();
            delete pCreateItemDlg;

            pModifyItemDlg->DestroyWindow();
            delete pModifyItemDlg;

            pLoadSaveDlg->DestroyWindow();
            delete pLoadSaveDlg;

        }
        break;
    }
    
    
    return CFormView ::WindowProc(message, wParam, lParam);
}


void CAppForm::SaveSettings()
{
    
}

//-----------------------------------------------------------------------------
// Name: CAppForm::InvalidateDeviceObjects()
// Desc: Called when the device-dependent objects are about to be lost.
//-----------------------------------------------------------------------------
HRESULT CAppForm::InvalidateDeviceObjects()
{
    // TODO: Cleanup any objects created in RestoreDeviceObjects()
    SAFE_RELEASE( m_pDIConfigSurface );

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: CAppForm::DeleteDeviceObjects()
// Desc: Called when the app is exiting, or the device is being changed,
//       this function deletes any device dependent objects.
//-----------------------------------------------------------------------------
HRESULT CAppForm::DeleteDeviceObjects()
{
    // TODO: Cleanup any objects created in InitDeviceObjects()
    SAFE_RELEASE( m_pVB );
    delete pEditUI;
    
    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: CAppForm::FinalCleanup()
// Desc: Called before the app exits, this function gives the app the chance
//       to cleanup after itself.
//-----------------------------------------------------------------------------
HRESULT CAppForm::FinalCleanup()
{
    // Write the settings to the registry
    WriteSettings();

    /* Free all allocated memory */
    PR_FreeCamera (camera);
    PR_FreeEntity (entity);
    PR_FreeObject (object_shape);
    PR_FreeLights (&userlights);
    PR_FreeLights (&PR_Globals.scenelights);

    PR_FreeFont (Font_Impact);

    PR_DeleteAllTextures ();
    PR_DeleteAllMaterials ();
    PR_ShutDown ();

    return S_OK;
}



//-----------------------------------------------------------------------------
// Name: InitInstance()
// Desc: This is the main entry point for the application. The MFC window stuff
//       is initialized here. See also the main initialization routine for the
//       CAppForm class, which is called indirectly from here.
//-----------------------------------------------------------------------------
BOOL CApp::InitInstance()
{
    // Asscociate the MFC app with the frame window and doc/view classes
    AddDocTemplate( new CSingleDocTemplate( IDR_MAINFRAME,
                                            RUNTIME_CLASS(CAppDoc),
                                            RUNTIME_CLASS(CAppFrameWnd),
                                            RUNTIME_CLASS(CAppForm) ) );

    // Dispatch commands specified on the command line (req'd by MFC). This
    // also initializes the the CAppDoc, CAppFrameWnd, and CAppForm classes.
    CCommandLineInfo cmdInfo;
    ParseCommandLine( cmdInfo );
    if( !ProcessShellCommand( cmdInfo ) )
        return FALSE;

    if( !g_AppFormView->IsReady() )
        return FALSE;

    g_AppFormView->GetParentFrame()->RecalcLayout();
    g_AppFormView->ResizeParentToFit( FALSE ); 
    
    m_pMainWnd->SetWindowText( g_strAppTitle );
    m_pMainWnd->UpdateWindow();

    return TRUE;
}




//-----------------------------------------------------------------------------
// Name: LoadFrame()
// Desc: Uses idle time to render the 3D scene.
//-----------------------------------------------------------------------------
BOOL CAppFrameWnd::LoadFrame(UINT nIDResource, DWORD dwDefaultStyle, CWnd* pParentWnd, CCreateContext* pContext) 
{
    BOOL bResult = CFrameWnd::LoadFrame(nIDResource, dwDefaultStyle, pParentWnd, pContext);

    LoadAccelTable( MAKEINTRESOURCE(IDR_MAIN_ACCEL) );

    return bResult;
}




//-----------------------------------------------------------------------------
// Name: OnIdle()
// Desc: Uses idle time to render the 3D scene.
//-----------------------------------------------------------------------------
BOOL CApp::OnIdle( LONG )
{
    // Do not render if the app is minimized
    if( m_pMainWnd->IsIconic() )
        return FALSE;

    TCHAR strStatsPrev[200];

    lstrcpy(strStatsPrev, g_AppFormView->PstrFrameStats());

    // Update and render a frame
    if( g_AppFormView->IsReady() )
    {
        g_AppFormView->CheckForLostFullscreen();
        g_AppFormView->RenderScene();
    }

    // Keep requesting more idle time
    return TRUE;
}




//-----------------------------------------------------------------------------
// Name: PreCreateWindow()
// Desc: Change the window style (so it cannot maximize or be sized) before
//       the main frame window is created.
//-----------------------------------------------------------------------------
BOOL CAppFrameWnd::PreCreateWindow( CREATESTRUCT& cs )
{
    cs.style = WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX;

    return CFrameWnd::PreCreateWindow( cs );
}




//-----------------------------------------------------------------------------
// Name: ~CAppForm()
// Desc: Destructor for the dialog resource form. Shuts down the app
//-----------------------------------------------------------------------------
CAppForm::~CAppForm()
{
    Cleanup3DEnvironment();
}




//-----------------------------------------------------------------------------
// Name: OnToggleFullScreen()
// Desc: Called when user toggles the fullscreen mode
//-----------------------------------------------------------------------------
void CAppForm::OnToggleFullScreen()
{
    ToggleFullscreen();
}




//-----------------------------------------------------------------------------
// Name: OnChangeDevice()
// Desc: Use hit the "Change Device.." button. Display the dialog for the user
//       to select a new device/mode, and call Change3DEnvironment to
//       use the new device/mode.
//-----------------------------------------------------------------------------
VOID CAppForm::OnChangeDevice()
{
    Pause(TRUE);

    UserSelectNewDevice();

    // Update UI
    UpdateUIForDeviceCapabilites();

    Pause(FALSE);
}




//-----------------------------------------------------------------------------
// Name: AdjustWindowForChange()
// Desc: Adjusts the window properties for windowed or fullscreen mode
//-----------------------------------------------------------------------------
HRESULT CAppForm::AdjustWindowForChange()
{
    if( m_bWindowed )
    {
        ::ShowWindow( m_hwndRenderFullScreen, SW_HIDE );
        CD3DApplication::m_hWnd = m_hwndRenderWindow;
    }
    else
    {
        if( ::IsIconic( m_hwndRenderFullScreen ) )
            ::ShowWindow( m_hwndRenderFullScreen, SW_RESTORE );
        ::ShowWindow( m_hwndRenderFullScreen, SW_SHOW );
        CD3DApplication::m_hWnd = m_hwndRenderFullScreen;
    }

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: FullScreenWndProc()
// Desc: The WndProc funtion used when the app is in fullscreen mode. This is
//       needed simply to trap the ESC key.
//-----------------------------------------------------------------------------
LRESULT CALLBACK FullScreenWndProc( HWND hWnd, UINT msg, WPARAM wParam,
                                    LPARAM lParam )
{
    if( msg == WM_CLOSE )
    {
        // User wants to exit, so go back to windowed mode and exit for real
        g_AppFormView->OnToggleFullScreen();
        g_App.GetMainWnd()->PostMessage( WM_CLOSE, 0, 0 );
    }
    else if( msg == WM_SETCURSOR )
    {
        SetCursor( NULL );
    }
    else if( msg == WM_KEYUP && wParam == VK_ESCAPE )
    {
        // User wants to leave fullscreen mode
        g_AppFormView->OnToggleFullScreen();
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}




//-----------------------------------------------------------------------------
// Name: CheckForLostFullscreen()
// Desc: If fullscreen and device was lost (probably due to alt-tab), 
//       automatically switch to windowed mode
//-----------------------------------------------------------------------------
HRESULT CAppForm::CheckForLostFullscreen()
{
    HRESULT hr;

    if( m_bWindowed )
        return S_OK;

    if( FAILED( hr = m_pd3dDevice->TestCooperativeLevel() ) )
        ForceWindowed();

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: UpdateUIForDeviceCapabilites()
// Desc: Whenever we get a new device, call this function to enable/disable the
//       appropiate UI controls to match the device's capabilities.
//-----------------------------------------------------------------------------
VOID CAppForm::UpdateUIForDeviceCapabilites()
{
    // TODO: Check the capabilities of the device and update the UI as needed
    DWORD dwCaps = m_d3dCaps.RasterCaps;
}




//-----------------------------------------------------------------------------
// Name: OnInitialUpdate()
// Desc: When the AppForm object is created, this function is called to
//       initialize it. Here we getting access ptrs to some of the controls,
//       and setting the initial state of some of them as well.
//-----------------------------------------------------------------------------
VOID CAppForm::OnInitialUpdate()
{
    // Update the UI
    CFormView::OnInitialUpdate();

    // Get the top level parent hwnd
    m_hWndTopLevelParent = GetTopLevelParent()->GetSafeHwnd();

    // Save static reference to the render window
    m_hwndRenderWindow = GetDlgItem(IDC_RENDERVIEW)->GetSafeHwnd();

    // Register a class for a fullscreen window
    WNDCLASS wndClass = { CS_HREDRAW | CS_VREDRAW, FullScreenWndProc, 0, 0, NULL,
                          NULL, NULL, (HBRUSH)GetStockObject(WHITE_BRUSH), NULL,
                          _T("Fullscreen Window") };
    RegisterClass( &wndClass );

    // We create the fullscreen window (not visible) at startup, so it can
    // be the focus window.  The focus window can only be set at CreateDevice
    // time, not in a Reset, so ToggleFullscreen wouldn't work unless we have
    // already set up the fullscreen focus window.
    m_hwndRenderFullScreen = CreateWindow( _T("Fullscreen Window"), NULL,
                                           WS_POPUP, CW_USEDEFAULT,
                                           CW_USEDEFAULT, 100, 100,
                                           m_hWndTopLevelParent, 0L, NULL, 0L );

    // Note that for the MFC samples, the device window and focus window
    // are not the same.
    CD3DApplication::m_hWnd = m_hwndRenderWindow;
    CD3DApplication::m_hWndFocus = m_hwndRenderFullScreen;
    CD3DApplication::Create( AfxGetInstanceHandle() );


    CScrollBar *pVScroll = (CScrollBar*)GetDlgItem(IDC_VERTICAL_SCROLL);
    pVScroll->SetScrollRange(0,1200);

    CScrollBar *pHScroll = (CScrollBar*)GetDlgItem(IDC_HORIZONTAL_SCROLL);
    pHScroll->SetScrollRange(0,1600);
}





const char *strTab1 = "Create";
const char *strTab2 = "Modify";
const char *strTab3 = "Load/Save";
const char *strTab4 = "Test";

void CAppForm::InitTabControl()
{
    m_TabControl.InsertItem(0,strTab1);
    m_TabControl.InsertItem(1,strTab2);
    m_TabControl.InsertItem(2,strTab3);
    m_TabControl.InsertItem(3,strTab4);
}




void CAppForm::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	// Do not call CFormView ::OnPaint() for painting messages
}

void CAppForm::OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult) 
{
    CTabCtrl *pTab = (CTabCtrl*)GetDlgItem(IDC_TAB1);
    switch(pTab->GetCurSel())
    {
        case 0:
            {
                pCreateItemDlg->ShowWindow(SW_SHOW);
                pModifyItemDlg->ShowWindow(SW_HIDE);
                pLoadSaveDlg->ShowWindow(SW_HIDE);
                pTestItemDlg->ShowWindow(SW_HIDE);
                pCreateItemDlg->m_pCreatePictureDlg->GetDlgItem(IDC_TEXTURE_LIST)->SetFocus();
            }
            break;
        case 1:
            {            
                pCreateItemDlg->ShowWindow(SW_HIDE);
                pModifyItemDlg->ShowWindow(SW_SHOW);
                pLoadSaveDlg->ShowWindow(SW_HIDE);
                pTestItemDlg->ShowWindow(SW_HIDE);
                pModifyItemDlg->SetFocus();
            }
            break;
        case 2:
            {
                pCreateItemDlg->ShowWindow(SW_HIDE);
                pModifyItemDlg->ShowWindow(SW_HIDE);
                pTestItemDlg->ShowWindow(SW_HIDE);
                pLoadSaveDlg->ShowWindow(SW_SHOW);
                pLoadSaveDlg->GetDlgItem(IDC_SAVE_LIST)->SetFocus();
            }
            break;
        case 3:
            {
                pCreateItemDlg->ShowWindow(SW_HIDE);
                pModifyItemDlg->ShowWindow(SW_HIDE);
                pLoadSaveDlg->ShowWindow(SW_HIDE);
                pTestItemDlg->ShowWindow(SW_SHOW);
                
                CSliderCtrl *pSlider = (CSliderCtrl*)pTestItemDlg->GetDlgItem(IDC_OPACITY_SLIDER);
                CWnd *pEdit = pTestItemDlg->GetDlgItem(IDC_EDIT_OPACITY);

                pSlider->SetPos(pEditUI->m_pUIManager->m_opacity);

                CString s;
                s.Format("%d",pEditUI->m_pUIManager->m_opacity);
                pEdit->SetWindowText(s);
            }
            break;
    }
}

BOOL CALLBACK resizeCallback(HWND hWnd,LPARAM lParam)
{
    return TRUE;
}

void viewportResize(int width,int height)
{
  if (!PR_Settings.UseWindowed)
    return;

  if ((width == 0) || (height == 0))
    return;
 
  /* Need this so clipping is done correctly */
  PR_Globals.PR_OutputDevice.width = width;
  PR_Globals.PR_OutputDevice.height = height;

  if (PR_Globals.active_viewport.width > 0)
  {
        PR_ResizeViewport (&PR_Globals.active_viewport, 0, 0, width-1, height-1);

        PR_ReleaseUserTextures ();
        std::vector<CZUIFont*>::iterator iterFont =  pEditUI->m_pUIManager->m_FontList.begin();
        for(;iterFont != pEditUI->m_pUIManager->m_FontList.end(); iterFont++)
        {
            CZUIFont *pFont = (*iterFont);
            pFont->InvalidateDevice();
        }

        if (PR_Globals.PR_BackBuffer != NULL)
        {
            PR_Globals.PR_BackBuffer->Release();
            PR_Globals.PR_BackBuffer= NULL;
        }   

        PR_Globals.PR_DisplayDevices[PR_Globals.PR_Monitor1Driver].d3dpp.BackBufferWidth = width;
        PR_Globals.PR_DisplayDevices[PR_Globals.PR_Monitor1Driver].d3dpp.BackBufferHeight = height;
        PR_Globals.PR_DisplayDevices[PR_Globals.PR_Monitor1Driver].lpD3DDevice->Reset( 
          &PR_Globals.PR_DisplayDevices[PR_Globals.PR_Monitor1Driver].d3dpp);

        PR_Globals.PR_DisplayDevices[PR_Globals.PR_CurrentMonitor].lpD3DDevice->GetBackBuffer (
         0, D3DBACKBUFFER_TYPE_MONO, &PR_Globals.PR_BackBuffer);
        PR_Globals.PR_RenderTarget = PR_Globals.PR_BackBuffer;
        PR_RestoreUserTextures ();

        iterFont =  pEditUI->m_pUIManager->m_FontList.begin();
        for(;iterFont != pEditUI->m_pUIManager->m_FontList.end(); iterFont++)
        {
            CZUIFont *pFont = (*iterFont);
            pFont->RestoreDevice();
        }
  }
    

  if (PR_Globals.PR_CurrentCamera != NULL)
    PR_Globals.PR_CurrentCamera->aspect_ratio = (PR_REAL)width / (PR_REAL)height;
}



void CAppFrameWnd::OnSize(UINT nType, int cx, int cy) 
{
    
	CFrameWnd::OnSize(nType, cx, cy);
    CWnd *pFormView = g_AppFormView;
    if(pFormView)
    {
        CWnd* pTab = pFormView->GetDlgItem(IDC_TAB1);

        RECT r = {0};
        pTab->GetClientRect(&r);
        r.left = cx - 238;
        r.right = cx-5;
        r.bottom += 5;
        pTab->MoveWindow(&r);

        CWnd *pRender = pFormView->GetDlgItem(IDC_RENDERVIEW);

        pRender->GetClientRect(&r);
        r.left = 0;
        r.right = cx - 259;
        r.top = 0;
        r.bottom = cy-20;
        pRender->MoveWindow(&r);

        int viewportRight = r.right;
        int viewportHeight = r.bottom;

        CWnd *pVScroll = pFormView->GetDlgItem(IDC_VERTICAL_SCROLL);
        pVScroll->GetClientRect(&r);

        int scrollWidth = r.right - r.left;
        r.right = viewportRight + scrollWidth;
        r.left = r.right - scrollWidth;
        r.bottom = viewportHeight;
        pVScroll->MoveWindow(&r);

        CWnd *pHScroll = pFormView->GetDlgItem(IDC_HORIZONTAL_SCROLL);
        pHScroll->GetClientRect(&r);

        int scrollHeight = r.bottom - r.top;
        r.right = viewportRight;
        r.left = 0;
        r.top = viewportHeight;
        r.bottom = viewportHeight + scrollHeight;
        pHScroll->MoveWindow(&r);


        RECT rWin;
        pRender->GetWindowRect(&rWin);

        pRender->GetClientRect (&PR_Globals.PR_rcViewportRect);
        pRender->GetClientRect (&PR_Globals.PR_rcScreenRect);

        if(g_pDevice)
            viewportResize(rWin.right-rWin.left,rWin.bottom -rWin.top);
    }
}

void CAppForm::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
        static int iPos = 0;
    int lastPos = 0;

    int change = 0;

    switch(nSBCode)
    {
    case SB_BOTTOM:
        change = 1200 - iPos;
        iPos = 1200;
        break;
    case SB_TOP:
        change = -iPos;
        iPos = 0;
        break;
    case SB_LINEDOWN:
        lastPos = iPos;
        iPos+=20;
        if(iPos > 1200)
            iPos = 1200;

        change = iPos - lastPos;
        break;
    case SB_LINEUP:
        lastPos = iPos;
        iPos-=20;
        if(iPos < 0)
            iPos = 0;

        change = iPos - lastPos;
        break;
    case SB_PAGEDOWN:
        lastPos = iPos;
        iPos += 200;
        if(iPos > 1200)
            iPos = 1200;
        change = iPos - lastPos;
        break;
    case SB_PAGEUP:
        lastPos = iPos;
        iPos -= 200;
        if(iPos < 0)
            iPos = 0;
        change = iPos - lastPos;
        break;
    case SB_THUMBPOSITION:
    case SB_THUMBTRACK:
        lastPos = iPos;
        iPos = nPos;
        change = iPos - lastPos;
        break;
    }
    pScrollBar->SetScrollPos(iPos);

    pEditUI->m_pUIManager->m_yoffset = iPos;


    std::vector<CZUIItem *>::iterator iter = pEditUI->m_pUIManager->m_ItemList.begin();
    for(;iter != pEditUI->m_pUIManager->m_ItemList.end();iter++)
    {
        CZUIItem *pItem = (*iter);

        pItem->y -= change;
        for(int x=0;x<4;x++)
        {
            pItem->m_pVerts[x].y -= change;
            pItem->m_pVerts[x].color = D3DCOLOR_ARGB(pItem->m_iTranslucency,255,255,255);
        }
    }

    Render();


	CFormView ::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CAppForm::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{	
    static int iPos = 0;
    int lastPos = 0;

    int change = 0;

    switch(nSBCode)
    {
    case SB_BOTTOM:
        change = 1600 - iPos;
        iPos = 1600;
        break;
    case SB_TOP:
        change = -iPos;
        iPos = 0;
        break;
    case SB_LINEDOWN:
        lastPos = iPos;
        iPos+=20;
        if(iPos > 1600)
            iPos = 1600;

        change = iPos - lastPos;
        break;
    case SB_LINEUP:
        lastPos = iPos;
        iPos-=20;
        if(iPos < 0)
            iPos = 0;

        change = iPos - lastPos;
        break;
    case SB_PAGEDOWN:
        lastPos = iPos;
        iPos += 200;
        if(iPos > 1600)
            iPos = 1600;
        change = iPos - lastPos;
        break;
    case SB_PAGEUP:
        lastPos = iPos;
        iPos -= 200;
        if(iPos < 0)
            iPos = 0;
        change = iPos - lastPos;
        break;
    case SB_THUMBPOSITION:
    case SB_THUMBTRACK:
        lastPos = iPos;
        iPos = nPos;
        change = iPos - lastPos;
        break;
    }
    pScrollBar->SetScrollPos(iPos);

    pEditUI->m_pUIManager->m_xoffset = iPos;


    std::vector<CZUIItem *>::iterator iter = pEditUI->m_pUIManager->m_ItemList.begin();
    for(;iter != pEditUI->m_pUIManager->m_ItemList.end();iter++)
    {
        CZUIItem *pItem = (*iter);

        pItem->x -= change;
        for(int x=0;x<4;x++)
        {
            pItem->m_pVerts[x].x -= change;
            pItem->m_pVerts[x].color = D3DCOLOR_ARGB(pItem->m_iTranslucency,255,255,255);
        }
    }

    Render();

	CFormView ::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CAppFrameWnd::OnVscreen1024768() 
{
    pEditUI->m_pUIManager->m_virtualWidth = 1024;
    pEditUI->m_pUIManager->m_virtualHeight = 768;

    CMenu *pMenu = (CMenu*)GetMenu();
    
    pMenu->CheckMenuItem(ID_VSCREEN_640480 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_800600 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_1024768 ,MF_CHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_16001200 ,MF_UNCHECKED);
}

void CAppFrameWnd::OnVscreen16001200() 
{
    pEditUI->m_pUIManager->m_virtualWidth = 1600;
    pEditUI->m_pUIManager->m_virtualHeight = 1200;

    CMenu *pMenu = (CMenu*)GetMenu();
    
    pMenu->CheckMenuItem(ID_VSCREEN_640480 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_800600 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_1024768 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_16001200 ,MF_CHECKED);
}

void CAppFrameWnd::OnVscreen640480() 
{
    pEditUI->m_pUIManager->m_virtualWidth = 640;
    pEditUI->m_pUIManager->m_virtualHeight = 480;

    CMenu *pMenu = (CMenu*)GetMenu();
    
    pMenu->CheckMenuItem(ID_VSCREEN_640480 ,MF_CHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_800600 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_1024768 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_16001200 ,MF_UNCHECKED);
}

void CAppFrameWnd::OnVscreen800600() 
{
	pEditUI->m_pUIManager->m_virtualWidth = 800;
    pEditUI->m_pUIManager->m_virtualHeight = 600;
    CMenu *pMenu = (CMenu*)GetMenu();
    
    pMenu->CheckMenuItem(ID_VSCREEN_640480 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_800600 ,MF_CHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_1024768 ,MF_UNCHECKED);
    pMenu->CheckMenuItem(ID_VSCREEN_16001200 ,MF_UNCHECKED);
}
